package se.nekotronic.udpreceiver;

import android.os.Bundle;
import android.app.Activity;
import android.text.format.Time;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class UDPReceiveActivity extends Activity implements OnClickListener {
	public static final int PORT = 2004;
	private TextView output_area;
	private Button start_button;
	private Button stop_button;
	private UDPServerThread server_thread;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_udpreceive);
		output_area = (TextView)findViewById(R.id.output_area);
		output_area.setMovementMethod(new ScrollingMovementMethod());
		start_button = (Button)findViewById(R.id.start_button);
		start_button.setOnClickListener(this);
		stop_button = (Button)findViewById(R.id.stop_button);
		stop_button.setOnClickListener(this);

		output_area.setText("");
		print("AndroidPinger: Appen startar.");

	}

	@Override
	protected void onPause() {
		super.onPause();
		stop_server_thread();
	}

	public void onClick(View view) {
		Log.d("*** OnePinger", "Button clicked: view = " + view.toString() + "\n");
		if (view == start_button) {
			if (server_thread != null) {
				warning("Already running.");
			}
			else {
				server_thread = new UDPServerThread(this, PORT);
				server_thread.start();
			}
		}
		else if (view == stop_button) {
			stop_server_thread();
			// this.finish();
		}
	} // onClick

	private void stop_server_thread() {
		print("Stopping server thread (if one)");
		if (server_thread != null) {
			server_thread.please_stop();
			server_thread = null;
		}
	}

	public void print(String message) {
		Log.d("*** OnePinger", "message: " + message);
		Time now = new Time();
		now.setToNow();
		String timeString = now.format("%H:%M:%S");
		final String line = timeString + ": " + message + "\n";
		output_area.post(new Runnable() {
			@Override
			public void run() {
				output_area.setText(output_area.getText() + line);
				// Hr borde vi scrolla automatiskt
				output_area.invalidate();
			}
		});
	} // print

	public void warning(String message) {
		print("Warning! " + message);
	}
} // UDOReceiveActivity
